/* program2.c
   
   --Demogramm fr die getopt_long-Funktion (GNU)

   Autor: Michael Uelschen, Universitt Gesamthochschule Kassel, 3/98
          uelschen@ite.maschinenbau.uni-kassel.de

   Das Programm verarbeitet die bergebenen Parameter mit der GNU 
   getopt_long Funktion. Zum bersetzen ist der GNU Compiler bzw.
   die GNU C-Bibliothek notwendig!                                 */

#include <stdlib.h>
#include <stdio.h>
#include <getopt.h>

/* --Die mglichen Optionen (in Kurzschreibweise) */
char* options="hVp:a:A:78";

/* --Die mglichen Optionen (in Langschreibweise) */
struct option longoptions[]={
  {"help",no_argument,0,'h'},
  {"version",no_argument,0,'v'},
  {"papersize",required_argument,0,'p'},
  {"first-page",required_argument,0,'a'},
  {"bit",required_argument,0,300}
};

int main(int argc, char* argv[]) {
  extern char* optarg;		/* Zeiger auf das aktuelle Argument */
  extern int optind;		/* Zhler fr verarbeitete Optionen */
  int val;

  /* --Optionale Parameter */
  char* papersize="a4";
  long firstpage=0;
  int bit8=0;
  char* infile=(char*)NULL;
  char* outfile=(char*)NULL;
  int longind;

  while ((val=getopt_long(argc,argv,options,longoptions,&longind))!=EOF) {
    switch (val) {
    case 'h' : printf("usage: program {<options>} infile outfile\n"); exit(0);
    case 'V' : printf("MU Program Version 1.0, 03/03/98\n"); exit(0);
    case 'p' : papersize=optarg; break;
    case 'a' : ;
    case 'A' : firstpage=atol(optarg); break;
    case '7' : bit8=0; break;
    case '8' : bit8=1; break;
    case 300 : 
      if (!strcmp(optarg,"8"))
	bit8=1;
      else 
	bit8=0;
      break;
    }
  }

  /* --berprfe, ob infile und outfile angegeben worden sind. */
  if (optind<argc)
    infile=argv[optind++];
  else {
    printf("program: no infile spezified.\n");
    exit(1);
  }
  
  if(optind<argc)
    outfile=argv[optind];
  else {
    printf("program: no outfile spezified.\n");
    exit(1);
  }

  printf("papersize=%s, firstpage=%ld, %s, infile=%s, outfile=%s\n",
	 papersize,firstpage,(bit8?"8bit":"7bit"),infile,outfile);


  return 0;
}
